commit b75abf5b597630e562e91c9431c025d250045311
Author: Arnold D. Robbins <arnold@skeeve.com>
Date:   Sat Sep 17 21:53:51 2022 +0300

    Bug fix for rwarray.c and doc and test updates.

diff --git a/doc/ChangeLog b/doc/ChangeLog
index ffe739de..0ccc653d 100644
--- a/doc/ChangeLog
+++ b/doc/ChangeLog
@@ -1,3 +1,8 @@
+2022-09-17         Arnold D. Robbins     <arnold@skeeve.com>
+
+	* gawktexi.in (Extension Sample Read write array): Clarify how readall
+	works. Thanks to J Naman, <gawker@703n.com> for the prod.
+
 2022-09-04         Arnold D. Robbins     <arnold@skeeve.com>
 
 	* 5.2.0: Release tar ball made.
diff --git a/doc/gawktexi.in b/doc/gawktexi.in
index a9274424..97445ace 100644
--- a/doc/gawktexi.in
+++ b/doc/gawktexi.in
@@ -39020,7 +39020,8 @@ It returns one on success, or zero upon failure
 This function takes a string argument, which is the name of the
 file from which to read the contents of various global variables.
 For each variable in the file, the data is loaded unless the variable
-already exists. If the variable already exists, the data for that variable
+has already been assigned a value or used as an array.
+In that case, the data for that variable
 in the file is ignored.
 It returns one on success, or zero upon failure.
 @end table
diff --git a/extension/ChangeLog b/extension/ChangeLog
index 2fb0edff..db568436 100644
--- a/extension/ChangeLog
+++ b/extension/ChangeLog
@@ -1,3 +1,8 @@
+2022-09-17         Arnold D. Robbins     <arnold@skeeve.com>
+
+	* rwarray.c (do_poke): Handle namespaced variables (foo::bar).
+	Thanks to J Naman, <gawker@703n.com> for the report.
+
 2022-09-04         Arnold D. Robbins     <arnold@skeeve.com>
 
 	* 5.2.0: Release tar ball made.
diff --git a/extension/rwarray.c b/extension/rwarray.c
index 3e09102e..1a3a7d10 100644
--- a/extension/rwarray.c
+++ b/extension/rwarray.c
@@ -454,15 +454,34 @@ do_poke(awk_element_t *e)
 
 	if (e->index.val_type != AWK_STRING)
 		return awk_false;
-	/* So this is a bit tricky. If the program refers to the variable,
+	/*
+	 * So this is a bit tricky. If the program refers to the variable,
 	 * then it will already exist in an undefined state after parsing.
 	 * If the program never refers to it, then the lookup fails.
 	 * We still need to create it in case the program accesses it via
-	 * indirection through the SYMTAB table. */
-	if (sym_lookup(e->index.str_value.str, AWK_UNDEFINED, &t) && (t.val_type != AWK_UNDEFINED))
+	 * indirection through the SYMTAB table.
+	 */
+	// it's even trickier, we need to handle foo::bar as well
+	char *p = strstr(e->index.str_value.str, "::");
+	char *ns, *ident;
+	if (p != NULL) {
+		ns = e->index.str_value.str;
+		ident = p + 2;
+		*p = '\0';
+	} else {
+		ns = "";
+		ident = e->index.str_value.str;
+	}
+
+	if (sym_lookup_ns(ns, ident, AWK_UNDEFINED, & t)
+	    && (t.val_type != AWK_UNDEFINED))
 		return awk_false;
-	if (! sym_update(e->index.str_value.str, & e->value)) {
-		warning(ext_id, _("readall: unable to set %s"), e->index.str_value.str);
+
+	if (! sym_update_ns(ns, ident, & e->value)) {
+		if (ns[0])
+			warning(ext_id, _("readall: unable to set %s::%s"), ns, ident);
+		else
+			warning(ext_id, _("readall: unable to set %s"), ident);
 		return awk_false;
 	}
 	return awk_true;
diff --git a/test/ChangeLog b/test/ChangeLog
index 6ec48cfd..b7e506a3 100644
--- a/test/ChangeLog
+++ b/test/ChangeLog
@@ -1,3 +1,7 @@
+2022-09-17         Arnold D. Robbins     <arnold@skeeve.com>
+
+	* readall.ok, readall1.awk, readall2.awk: Update for code changes.
+
 2022-09-16         Arnold D. Robbins     <arnold@skeeve.com>
 
 	* Makefile.am (EXTRA_DIST): New test: dbugeval4.
diff --git a/test/readall.ok b/test/readall.ok
index b343af59..8aa6899f 100644
--- a/test/readall.ok
+++ b/test/readall.ok
@@ -1,6 +1,7 @@
 1
 1
 5.9 3 -2.327
+42
 zebra[archie] = banana
 zebra[0] = apple
 zebra[3][foo] = bar
diff --git a/test/readall1.awk b/test/readall1.awk
index 2888d157..4f90c73d 100644
--- a/test/readall1.awk
+++ b/test/readall1.awk
@@ -2,6 +2,7 @@ BEGIN {
 	x = 5.9
 	y = 3
 	z = -2.327
+	guide::answer = 42
 	zebra[0] = "apple"
 	zebra["archie"] = "banana"
 	zebra[3]["foo"] = "bar"
diff --git a/test/readall2.awk b/test/readall2.awk
index 8b79849a..af45751d 100644
--- a/test/readall2.awk
+++ b/test/readall2.awk
@@ -10,6 +10,7 @@ function printarray(n, x,   i) {
 BEGIN {
 	print readall(ifile)
 	print x, y, z
+	print guide::answer
 	#print zebra[0], zebra[3]["foo"], zebra[3]["bar"]
 	printarray("zebra", zebra)
 }

